dnl TRY_CXX_FLAG(FLAG,[ACTION-IF-FOUND[,ACTION-IF-NOT-FOUND]])
AC_DEFUN(TRY_CXX_FLAG,
[echo >conftest.cc
if ${CXX-g++} ${CXXFLAGS} -c [$1] conftest.cc >/dev/null 2>&1; then
  ifelse([$2], , :, [rm -f conftest*
  $2])
else
  ifelse([$3], , :, [rm -f conftest*
  $3])
fi
rm -f conftest*])

AC_DEFUN(CXX_NO_RTTI,
[AC_CACHE_CHECK(whether ${CXX-g++} accepts -fno-rtti,
	local_cv_flag_NO_RTTI,
	TRY_CXX_FLAG(-fno-rtti,
		local_cv_flag_NO_RTTI=yes,
		local_cv_flag_NO_RTTI=no))
test "$local_cv_flag_NO_RTTI" = yes && CXXFLAGS="$CXXFLAGS -fno-rtti"
])

AC_DEFUN(CXX_NO_EXCEPTIONS,
[AC_CACHE_CHECK(whether ${CXX-g++} accepts -fno-exceptions,
	local_cv_flag_NO_EXCEPTIONS,
	TRY_CXX_FLAG(-fno-exceptions,
		local_cv_flag_NO_EXCEPTIONS=yes,
		local_cv_flag_NO_EXCEPTIONS=no))
test "$local_cv_flag_NO_EXCEPTIONS" = yes && CXXFLAGS="$CXXFLAGS -fno-exceptions"
])

dnl Test for buggy CXX
AC_DEFUN(TEST_BUGGY_CXX,
[echo -n "checking if your C++ compiler is buggy... "
cat > conftest.cc <<EOF
#line 921 "configure"
#include "confdefs.h"

class FOO {
unsigned foo(const int& key, unsigned hash);
unsigned foo(const int& key);
bool bar(const int& key) const { return foo(key); }
};
EOF
if ${CXX-g++} ${CXXFLAGS} -S conftest.cc >/dev/null 2>&1; then
  echo no
else
  echo yes
  echo You must upgrade before you can compile this package.
  rm -f conftest*
  exit 1
fi
rm -f conftest*
])
